// Language Logic
//Global Variables
var currentLanguage = "en";

const pgpPublicKey = `-----BEGIN PGP PUBLIC KEY BLOCK-----
Version: Keybase OpenPGP v2.0.76
Comment: https://keybase.io/crypto
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=+bY/
-----END PGP PUBLIC KEY BLOCK-----`;
const encryptedEmail = `-----BEGIN PGP MESSAGE-----

wy4ECQMIOVRNgwnwSSrgPokOBDHGAIh9vKbClKYgwTOO0kCmgbOeenecj7Pf
9ObB0lQBZc1Y0Dd7Yj3QndlRxBju+yzS9ki2YAQakw6xuaTuuajMTbxbB3Ft
trWRF6Wb4hTGtz0LwBXox/Cdi8JRjO2HMLHrRq5enUaN8M9NYIkfi44j+LU=
=RB4t
-----END PGP MESSAGE-----`

// Suggestion Table Data
var tabledata =[];
var numFilterOptions = 0;
var filterOptions = [];
var tabulatorElement;

// Instead of randomly choosing, we set a random order and iterate through 
// it so you'll see every suggestion before repeats
var repeatFreeOrder = [];
var currentIndex = 0;

suggestionTable = constructTableData();

function constructTableData(){
    tabledata = suggestions; // loaded from script at suggestions[LANG].js in js directory

    for( var index = 0; index < tabledata.length; index++){
        repeatFreeOrder.push(index);
    }
    var currentIndex = repeatFreeOrder.length;
      
    //Shuffle Elements
    while (currentIndex != 0) {
        var newIndex = Math.floor(Math.random() * currentIndex);
        currentIndex--;
        [repeatFreeOrder[currentIndex], repeatFreeOrder[newIndex]] = [repeatFreeOrder[newIndex], repeatFreeOrder[currentIndex]];
    }

    //Generate Filters
    generateFilterSelector();
    var contextFilterOptions = [];
    
    filterOptions.forEach(element=>{
        contextFilterOptions.push({
            label:element,
            value:element
        })
    });

    contextFilterOptions.push({label:"All",value:""});
    contextFilterOptions.sort((a, b) => {
        const stringA = a.value.toUpperCase(); // ignore upper and lowercase
        const stringB = b.value.toUpperCase(); // ignore upper and lowercase
        if (stringA < stringB) {
          return -1;
        }
        if (stringA > stringB) {
          return 1;
        }
        return 0;
      });

    tabulatorElement = new Tabulator("#suggestionData", {
        maxHeight: 300,
        minHeight: 80,
        rowHeight:34,
        data: tabledata,
        layout: "fitDataStretch",
        columns:[
            {title:"#", field: "id", width: 50, resizable:false},
            {title:"Context", field:"tags", width: 100, resizable:false},
            {title:"Specific Suggestion",field:"suggestion", resizable:false},     
        ]
    });

    tabulatorElement.on("rowClick", function(e, row){
        generateSuggestion(tabledata.findIndex((element)=>{
            if(element.id == row.getData().id){
                return true;
            }
        }))
    });

    tabulatorElement.on("rowTap", function(e, row){
        generateSuggestion(tabledata.findIndex((element)=>{
            if(element.id == row.getData().id){
                return true;
            }
        }))
    });

    tabulatorElement.on("cellDblTap", function(e, cell){
        scrollToTop();
    });

    document.getElementById("filter-context").addEventListener("change",function(){updateFilters();});
    document.getElementById("filter-suggestion").addEventListener("keyup",function(){updateFilters();});

    return tabulatorElement;       
};

//Work with filters
function updateFilters(){
    tabulatorElement.clearFilter();

    var contextFilter = document.getElementById("filter-context").options[document.getElementById("filter-context").selectedIndex].value;
    var suggestionFilter = document.getElementById("filter-suggestion").value;
   if(contextFilter == "Context"){
    contextFilter = "";
   }
    tabulatorElement.setFilter("tags","like",contextFilter);

    tabulatorElement.addFilter("suggestion","like",suggestionFilter);
};

// Chooses a random suggestion from our table and slips it into the webpage
var suggestionsGenerated = 0;
function generateSuggestion(specificOne){
    var saveHistory = false;
    if(typeof specificOne === 'string'){
        saveHistory = true;
        specificOne = parseInt(location.hash.substring(1));
        for( var searchIndex = 0; searchIndex < tabledata.length; searchIndex++){
            if(specificOne == tabledata[searchIndex].id){
                specificOne = searchIndex;
            }
        }
    }
    
    var workingSuggestion;
    if(suggestionsGenerated < 0){
        suggestionsGenerated = 0;
    }

    var numChecked = 0;
    var foundTagMatch = false;
    
    if(specificOne!== undefined && specificOne > -1 && specificOne < tabledata.length){
        workingSuggestion = tabledata[specificOne];
        for(var repeatOrderIndex = 0; repeatOrderIndex < repeatFreeOrder.length; repeatOrderIndex++){
            if(repeatFreeOrder[repeatOrderIndex] == specificOne){
                suggestionsGenerated = repeatOrderIndex;
            }
        }
    }
    else{
        suggestionsGenerated = suggestionsGenerated + 1;
        if(suggestionsGenerated > repeatFreeOrder.length-1 ){
            suggestionsGenerated = 0;
        }
        workingSuggestion = tabledata[repeatFreeOrder[suggestionsGenerated]];


        var relevantTags = [];
        workingSuggestion.tags.match(/[^,]+/g).forEach(element => {
            var trimmedString = element.trim();
            if(relevantTags.indexOf(trimmedString)  === -1){
                relevantTags.push(trimmedString);
            }
        });

        var filterOptions = document.getElementById("filterOptions").getElementsByTagName("input");

        for(var filterIndex = 0; filterIndex < filterOptions.length && !foundTagMatch; filterIndex++){    
            if(filterOptions[filterIndex].checked){
                numChecked = numChecked + 1;
                for(var relevantTagIndex = 0; relevantTagIndex < relevantTags.length; relevantTagIndex++){
                    if(relevantTags[relevantTagIndex]==filterOptions[filterIndex].value)
                    {
                        foundTagMatch = true;
                    }
                }
            }    
        }

    }

    if(numChecked > 0 && !foundTagMatch)
    {
        generateSuggestion();
    }
    else{
        document.getElementById("specificSuggestion").innerHTML = "<p>"+workingSuggestion.suggestion+"</p>";
        document.getElementById("suggestionCount").style= "rotate: "+((Math.sin(workingSuggestion.id+getIntHash(pgpPublicKey)))*3.0)+"deg;";
        document.getElementById("suggestionCount").innerHTML=workingSuggestion.id.toString().padStart(5, "0");
        
        //Sharing Versions
        document.getElementById("specificSuggestionShare").innerHTML = "<p>"+workingSuggestion.suggestion+"</p>";
        document.getElementById("suggestionCountShare").style= "rotate: "+((Math.sin(workingSuggestion.id+getIntHash(pgpPublicKey)))*3.0)+"deg;";
        document.getElementById("suggestionCountShare").innerHTML=workingSuggestion.id.toString().padStart(5, "0");

        if(document.getElementById("filterSelector").style.maxHeight &&  document.getElementById("filterSelector").style.maxHeight != "0px"){
            filterDropdown();
        }
            location.replace("#" + workingSuggestion.id);
    }
}

function generateFilterSelector(){
    filterOptions = [];
    for(var index = 0; index < tabledata.length; index++){
        var tags = tabledata[index].tags.match(/[^,]+/g); //Seperate out tags with regular expression
        tags.forEach(element => {
            var trimmedString = element.trim();
            if(filterOptions.indexOf(trimmedString)  === -1){
                filterOptions.push(trimmedString);
            }
        });
    }
    numFilterOptions = 0;
    var filterHTMLString = "";
    filterOptions.forEach(element => {
        numFilterOptions = numFilterOptions + 1;
        filterHTMLString += "<label><input type=\"checkbox\" name=\""+element+"\" value=\""+element+"\" checked>"+element+"</label>\n";
    
        //Table Filter Options
        var opt = document.createElement('option');
        opt.value = element;
        opt.innerHTML = element;
        document.getElementById("filter-context").appendChild(opt);
    });
    document.getElementById("filterOptions").innerHTML = filterHTMLString;

    document.getElementById("filterButton").addEventListener("click",function (e) {
        filterDropdown();
    });
    document.getElementById("filterSelector").addEventListener("click",function (e) {
        e.stopPropagation();
    });
}

// Triggering style changes when you drop down the filter selector
function filterDropdown(){
    var dropdown = document.getElementById("filterSelector");

    if(!dropdown.style.maxHeight){
        dropdown.style.maxHeight = "0px";
        generateSuggestion(repeatFreeOrder[suggestionsGenerated]);
    }

    if (dropdown.style.maxHeight == "0px"){
        dropdown.style.maxHeight = ( numFilterOptions * 1.75 )+"rem";
        dropdown.style.borderBottomWidth = "4px";
    }
    else{
        dropdown.style.maxHeight = "0px";
        dropdown.style.borderBottomWidth = "0px";
        generateSuggestion(repeatFreeOrder[suggestionsGenerated]);
    }
    
}

// Check if visiting for the first time
// True = First time
// False = Been Here Before
function checkIfFirstVisit(){
    generatePanicButton();
    // return true; // uncomment to test

    if(localStorage.getItem('0')){
        var expiration = Date.parse(localStorage.getItem('0'));
        if(expiration > Date.now()){
            document.getElementById("firstTimeVisitOverlay").style.display = "none";
            return false;
        }
    }
    var expiratonInDays = 3; 
    localStorage.setItem('0', new Date((Date.now() + expiratonInDays*24*60*60*1000)).toString());
    return true; 
}

function hideOverlay(){
    document.getElementById("firstTimeVisitOverlay").style.opacity = 0;

    setTimeout(function(){
        document.getElementById("firstTimeVisitOverlay").style.display = "none";
    }, 400);   
}

// Sharing
var currentlySharing = false
function toggleShare(){
    document.getElementById('shareURL').value = window.location.href;
    currentlySharing = !currentlySharing; // Flip bit
    if(currentlySharing){
        //check if over something important
        document.body.style.maxHeight = "100vh";
        document.body.style.overflowY = "hidden";
        document.getElementById("sharingOverlay").style.visibility = "visible";
        document.getElementById("sharingOverlay").style.top = "0px";
    }
    else{
        //check if over something important
        document.body.style.overflowY = "auto";
        document.body.style.maxHeight = "100%";
        setTimeout(function(){document.getElementById("sharingOverlay").style.visibility = "hidden";},500);
        document.getElementById("sharingOverlay").style.top = "-100vh";
    }
}

function setPortraitShareOrientation(){
    document.getElementById('sharingStage').setAttribute('class',''); 
    document.getElementById('sharingStage').classList.add('portrait');
    document.getElementById('orientationBox').classList.add('portrait');
}

function setSquareShareOrientation(){
    document.getElementById('sharingStage').setAttribute('class','');
    document.getElementById('orientationBox').setAttribute('class','')
}

async function copyShareURLtoClipboard(){
    try {
      await navigator.clipboard.writeText(document.getElementById("shareURL").value);
    } catch (err) {
        // Tried copying and failed
    }
  }

// Create shareable image from generated suggestion
function downloadSuggestion(){
    document.getElementById("sharingStage").classList.toggle("noBorder");
    html2canvas(document.getElementById("sharingStage"),{
        //options
        logging: false,
    }).then(function(canvas) {
        var imageName = "";
        var suggestionID = document.getElementById("suggestionCount").innerHTML;
        if(canvas.width == canvas.height){
            imageName= 'Suggestion-'+suggestionID+'.png';
        }
        else{
            imageName = 'Suggestion-'+suggestionID+'-Portrait.png';
        }
        
        if(navigator.canShare){
            canvas.toBlob(function(blob){
                const filesArray = [
                    new File([blob],imageName,
                        {type: "image/png",lastModified: new Date().getTime()})];
                    const shareData = {files: filesArray,};
                    navigator.share(shareData);
            },"image/png")
        }
        else{
            var link = document.createElement('a');
            link.download = imageName;
            link.href = canvas.toDataURL();
            link.click(); //Download The Image*/
        }
    });

    document.getElementById("sharingStage").classList.toggle("noBorder");
    
}

// Motivational Quotes
var quoteList = Array.prototype.slice.call(document.getElementsByClassName("motivationalQuote"));
var quoteCounter = 0;
var quoteTimeout = setTimeout(showQuote, 0);

// do a quick shuffle here
quoteList.sort(() => Math.random() - 0.5);

function showQuote(){
    clearTimeout(quoteTimeout);
    for(var index = 0; index < quoteList.length; index++){
        quoteList[index].classList.remove("active");
    }
    quoteList[quoteCounter].classList.add("active");
    quoteCounter = quoteCounter + 1;
    if(quoteCounter >= quoteList.length){
        quoteCounter = 0;
    }
    quoteTimeout = setTimeout(showQuote, 12000);
}

function quoteInfo(event, url){
    event.stopPropagation();
    window.open(url, '_blank');

}


// Utilites
// hash of String
function getIntHash(ourString){
    var hash  = 0;
    for (let index = 0; index < ourString.length; index++) {
        hash = hash + ourString.codePointAt(index);
      }
      return hash;
}

// Determine Touchscreen Capability
function is_touch_enabled() {
    return ( 'ontouchstart' in window ) || 
           ( navigator.maxTouchPoints > 0 ) ||
           ( navigator.msMaxTouchPoints > 0 );
}

// Scrolls everything to the top
function scrollToTop(){
    document.getElementById('manual').scrollTo({top: 0, behavior: 'smooth'});
    window.scrollTo({top: 0, behavior: 'smooth'});
}

//Returns anchor out of URL
function getAnchor() {
    return (document.URL.split('#').length > 1) ? document.URL.split('#')[1] : null;
}


// Goto Random URL
// exitURLS loaded in suggestion[lang].js files
function gotoRandomURL(){
    //window.location.replace(exitURLS[Math.floor(Math.random() * exitURLS.length)]);
    window.location.assign(exitURLS[Math.floor(Math.random() * exitURLS.length)]);
}

// Panic button
var panicButtonSensitivityInSeconds = 0.5;
var clickTimes = []
function generatePanicButton() {
    if(is_touch_enabled()){
        const pcElements = document.getElementsByClassName("pcView");
        for (let i = 0; i < pcElements.length; i++) {
            pcElements[i].style.display = "none";
        }
        panicButtonSensitivityInSeconds = panicButtonSensitivityInSeconds * 1.2;
    }
    else
    {
        const mobileElements = document.getElementsByClassName("mobileView");
        for (let i = 0; i < mobileElements.length; i++) {
            mobileElements[i].style.display = "none";
        }
    }
    document.addEventListener("pointerdown", clickTracker);
}

//Track how many clicks/touches happened recently.
function clickTracker(){
    clickTimes.push(Date.now());
    if(clickTimes.length > 3){
        var timeDifference = clickTimes[3]-clickTimes[0];
        if(timeDifference/1000.0 < panicButtonSensitivityInSeconds){
            gotoRandomURL();
        }
        clickTimes.shift();
    }
}

// Track Escape Key Presses
var escapeKeyPress = 0;
document.addEventListener("keyup", function(event) {
    if(event.key == "Escape"){
        escapeKeyPress += 1;
    }
    if (escapeKeyPress > 2){
        gotoRandomURL();
    }
  });



// Decrypt Email Address and Present
async function decryptEmailAddress(caller){
    caller.classList.add("fadeOut");
    const encryptedEmailAddress = await openpgp.readMessage({
        armoredMessage: encryptedEmail
    });
    const decryptedEmailAddress = await openpgp.decrypt({
        message: encryptedEmailAddress,
        passwords: pgpPublicKey
    });
    document.getElementById("emailAddress").innerHTML = "<a href=\"mailto:"+decryptedEmailAddress.data+"\">"+decryptedEmailAddress.data+"</a";
    document.getElementById("emailAddress").style.maxHeight = "1.5em";
    document.getElementById("emailAddress").style.opacity = "1.0";

}

function revealEncryptionTool(caller){
    caller.classList.add("fadeOut");

    document.getElementById("encryptionTool").style.maxHeight = "30em";
    document.getElementById("encryptionTool").style.opacity = "1";
    window.scrollTo(0, document.body.scrollHeight);
}

async function encryptMessage(){
    const message = await openpgp.createMessage({text: document.getElementById("textToEncrypt").value});
    const publicKey = await openpgp.readKey({ armoredKey: pgpPublicKey });
    const encryptedText = await openpgp.encrypt({
        message,
        encryptionKeys: publicKey
    });
    
    var fadeTimeInMS = 300;

    setTimeout(function(){
        document.getElementById("encryptedMessage").value = encryptedText;
    }, 
    fadeTimeInMS/2.0);
    

    document.getElementById("encryptedMessage").style.animationDuration = fadeTimeInMS+"ms;";
    if (document.getElementById("encryptedMessage").style.animationName == "fadeOutThenIn"){
        document.getElementById("encryptedMessage").style.animationName = "fadeOutThenInSwap";
    }
    else {
        document.getElementById("encryptedMessage").style.animationName = "fadeOutThenIn";
    }
}


async function copyEncryptedMessageToClipboard() {
        try {
          await navigator.clipboard.writeText(document.getElementById("encryptedMessage").value);
          document.getElementById("copyNotification").style.rotate = (Math.sin(Date.now())*37)+"deg";
          document.getElementById("copyNotification").classList.add("show");
         setTimeout(function(){
            document.getElementById("copyNotification").classList.remove("show")
        },
         750);
        } catch (err) {
            // Tried copying and failed
        }
}

// Initialize Webpage
generateSuggestion(location.hash);
checkIfFirstVisit();
